package javax.naming.directory;

import javax.naming.NamingEnumeration;
import javax.naming.Name;
import javax.naming.Context;
import javax.naming.NoInitialContextException;
import javax.naming.NotContextException;
import java.util.Hashtable;
import javax.naming.NamingException;
import javax.naming.InitialContext;

public class InitialDirContext extends InitialContext implements DirContext
{
    protected InitialDirContext(boolean lazy) throws NamingException {
        super(lazy);
    }
    
    public InitialDirContext() throws NamingException {
    }
    
    public InitialDirContext(Hashtable<?, ?> environment) throws NamingException {
        super(environment);
    }
    
    private DirContext getURLOrDefaultInitDirCtx(String name) throws NamingException {
        Context urlOrDefaultInitCtx = this.getURLOrDefaultInitCtx(name);
        if (!(urlOrDefaultInitCtx instanceof DirContext)) {
            if (urlOrDefaultInitCtx == null) {
                throw new NoInitialContextException();
            }
            throw new NotContextException("Not an instance of DirContext");
        }
        else {
            return (DirContext)urlOrDefaultInitCtx;
        }
    }
    
    private DirContext getURLOrDefaultInitDirCtx(Name name) throws NamingException {
        Context urlOrDefaultInitCtx = this.getURLOrDefaultInitCtx(name);
        if (!(urlOrDefaultInitCtx instanceof DirContext)) {
            if (urlOrDefaultInitCtx == null) {
                throw new NoInitialContextException();
            }
            throw new NotContextException("Not an instance of DirContext");
        }
        else {
            return (DirContext)urlOrDefaultInitCtx;
        }
    }
    
    @Override
    public Attributes getAttributes(String s) throws NamingException {
        return this.getAttributes(s, (String[])null);
    }
    
    @Override
    public Attributes getAttributes(String s, String[] array) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(s).getAttributes(s, array);
    }
    
    @Override
    public Attributes getAttributes(Name name) throws NamingException {
        return this.getAttributes(name, (String[])null);
    }
    
    @Override
    public Attributes getAttributes(Name name, String[] array) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(name).getAttributes(name, array);
    }
    
    @Override
    public void modifyAttributes(String s, int n, Attributes attributes) throws NamingException {
        this.getURLOrDefaultInitDirCtx(s).modifyAttributes(s, n, attributes);
    }
    
    @Override
    public void modifyAttributes(Name name, int n, Attributes attributes) throws NamingException {
        this.getURLOrDefaultInitDirCtx(name).modifyAttributes(name, n, attributes);
    }
    
    @Override
    public void modifyAttributes(String s, ModificationItem[] array) throws NamingException {
        this.getURLOrDefaultInitDirCtx(s).modifyAttributes(s, array);
    }
    
    @Override
    public void modifyAttributes(Name name, ModificationItem[] array) throws NamingException {
        this.getURLOrDefaultInitDirCtx(name).modifyAttributes(name, array);
    }
    
    @Override
    public void bind(String s, Object o, Attributes attributes) throws NamingException {
        this.getURLOrDefaultInitDirCtx(s).bind(s, o, attributes);
    }
    
    @Override
    public void bind(Name name, Object o, Attributes attributes) throws NamingException {
        this.getURLOrDefaultInitDirCtx(name).bind(name, o, attributes);
    }
    
    @Override
    public void rebind(String s, Object o, Attributes attributes) throws NamingException {
        this.getURLOrDefaultInitDirCtx(s).rebind(s, o, attributes);
    }
    
    @Override
    public void rebind(Name name, Object o, Attributes attributes) throws NamingException {
        this.getURLOrDefaultInitDirCtx(name).rebind(name, o, attributes);
    }
    
    @Override
    public DirContext createSubcontext(String s, Attributes attributes) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(s).createSubcontext(s, attributes);
    }
    
    @Override
    public DirContext createSubcontext(Name name, Attributes attributes) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(name).createSubcontext(name, attributes);
    }
    
    @Override
    public DirContext getSchema(String s) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(s).getSchema(s);
    }
    
    @Override
    public DirContext getSchema(Name name) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(name).getSchema(name);
    }
    
    @Override
    public DirContext getSchemaClassDefinition(String s) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(s).getSchemaClassDefinition(s);
    }
    
    @Override
    public DirContext getSchemaClassDefinition(Name name) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(name).getSchemaClassDefinition(name);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(String s, Attributes attributes) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(s).search(s, attributes);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(Name name, Attributes attributes) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(name).search(name, attributes);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(String s, Attributes attributes, String[] array) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(s).search(s, attributes, array);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(Name name, Attributes attributes, String[] array) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(name).search(name, attributes, array);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(String s, String s2, SearchControls searchControls) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(s).search(s, s2, searchControls);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(Name name, String s, SearchControls searchControls) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(name).search(name, s, searchControls);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(String s, String s2, Object[] array, SearchControls searchControls) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(s).search(s, s2, array, searchControls);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(Name name, String s, Object[] array, SearchControls searchControls) throws NamingException {
        return this.getURLOrDefaultInitDirCtx(name).search(name, s, array, searchControls);
    }
}
